Attribute VB_Name = "CiRegSettings"
Option Explicit
'===================================================================
' This file is provided as part of the ClearImage COM Development Kit
'
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT
' WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
' OF MERCHANTABILITY AND/OR FITNESS FOR A  PARTICULAR PURPOSE.
'
' Copyright (C) 2003.  Inlite Research, Inc. All rights reserved
'===================================================================

' API Function and Constant Declarations

  Global Const REG_SZ As Long = 1
  Global Const REG_DWORD As Long = 4

  Global Const HKEY_CLASSES_ROOT = &H80000000
  Global Const HKEY_CURRENT_USER = &H80000001
  Global Const HKEY_LOCAL_MACHINE = &H80000002
  Global Const HKEY_USERS = &H80000003

  Global Const ERROR_NONE = 0
  Global Const ERROR_BADDB = 1
  Global Const ERROR_BADKEY = 2
  Global Const ERROR_CANTOPEN = 3
  Global Const ERROR_CANTREAD = 4
  Global Const ERROR_CANTWRITE = 5
  Global Const ERROR_OUTOFMEMORY = 6
  Global Const ERROR_INVALID_PARAMETER = 7
  Global Const ERROR_ACCESS_DENIED = 8
  Global Const ERROR_INVALID_PARAMETERS = 87
  Global Const ERROR_NO_MORE_ITEMS = 259

  Global Const ERROR_SUCCESS = 0
  
  Private Const STANDARD_RIGHTS_ALL       As Long = &H1F0000
  Private Const KEY_QUERY_VALUE           As Long = &H1
  Private Const KEY_ENUMERATE_SUB_KEYS    As Long = &H8
  Private Const KEY_NOTIFY                As Long = &H10
  Private Const SYNCHRONIZE               As Long = &H100000
  Private Const READ_CONTROL              As Long = &H20000
  Private Const STANDARD_RIGHTS_READ      As Long = (READ_CONTROL)
  Global Const KEY_READ                  As Long = _
                                           ((STANDARD_RIGHTS_READ _
                                           Or KEY_QUERY_VALUE _
                                           Or KEY_ENUMERATE_SUB_KEYS _
                                           Or KEY_NOTIFY) _
                                           And (Not SYNCHRONIZE))

  Global Const KEY_ALL_ACCESS = &H3F


  Global Const REG_OPTION_NON_VOLATILE = 0

Declare Function RegCloseKey Lib "advapi32.dll" _
  (ByVal hKey As Long) As Long
Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias _
  "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, _
  ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions _
  As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes _
  As Long, phkResult As Long, lpdwDisposition As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias _
  "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, _
  ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As _
  Long) As Long
Declare Function RegQueryValueExString Lib "advapi32.dll" Alias _
  "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
  String, ByVal lpReserved As Long, lpType As Long, ByVal lpData _
  As String, lpcbData As Long) As Long
Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias _
  "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
  String, ByVal lpReserved As Long, lpType As Long, lpData As _
  Long, lpcbData As Long) As Long
Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias _
  "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
  String, ByVal lpReserved As Long, lpType As Long, ByVal lpData _
  As Long, lpcbData As Long) As Long
Declare Function RegSetValueExString Lib "advapi32.dll" Alias _
  "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
  ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As _
  String, ByVal cbData As Long) As Long
Declare Function RegSetValueExLong Lib "advapi32.dll" Alias _
  "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
  ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, _
  ByVal cbData As Long) As Long
Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" _
   (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As _
   String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As _
   Long, lpData As Any, lpcbData As Long) As Long

  

Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2
Global Const HWND_TOP = 0

Global Const SWP_NOMOVE = 2
Global Const SWP_NOSIZE = 1
Global Const SWP_NOACTIVATE = &H10
Global Const SWP_SHOWWINDOW = &H40

' Global Const SWP_FLAG = SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_SHOWWINDOW
Global Const SWP_FLAG = SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW

Public Declare Function SetWindowPos Lib "user32" _
  (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, _
   ByVal X As Long, ByVal y As Long, ByVal cx As Long, _
   ByVal cy As Long, ByVal wFlags As Long) As Long

Public Function SetKeyValue(hRoot As Long, sKeyName As String, sValueName As String, _
                        vValueSetting As Variant, Optional lValueType As Long = REG_SZ) As Boolean
  SetKeyValue = False
  Dim lRetVal As Long         'result of the SetValueEx function
  Dim hKey As Long         'handle of open key
    ' Try to create key
  CreateNewKey hRoot, sKeyName
    'open the specified key
  lRetVal = RegOpenKeyEx(hRoot, sKeyName, 0, _
                         KEY_ALL_ACCESS, hKey)
  If (lRetVal <> 0) Then Exit Function
  lRetVal = SetValueEx(hKey, sValueName, lValueType, vValueSetting)
  If (lRetVal = 0) Then SetKeyValue = True
  RegCloseKey (hKey)
End Function

Public Function QueryValue(hRoot As Long, sKeyName As String, _
            sValueName As String, Optional nSequrity As Long = KEY_READ) As Variant
    Dim lRetVal As Long         'result of the API functions
    Dim hKey As Long         'handle of opened key
    Dim vValue As Variant      'setting of queried value
    lRetVal = RegOpenKeyEx(hRoot, sKeyName, 0, _
        nSequrity, hKey)    ' KEY_ALL_ACCESS
    lRetVal = QueryValueEx(hKey, sValueName, vValue)
    QueryValue = vValue
    RegCloseKey (hKey)
End Function

Public Function CreateNewKey(lPredefinedKey As Long, sNewKeyName As String) As Boolean
  Dim hNewKey As Long         'handle to the new key
  Dim lRetVal As Long         'result of the RegCreateKeyEx function

  lRetVal = RegCreateKeyEx(lPredefinedKey, sNewKeyName, 0&, _
            vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, _
            0&, hNewKey, lRetVal)
  CreateNewKey = (lRetVal = 0)
  RegCloseKey (hNewKey)
End Function


Public Function SetValueEx(ByVal hKey As Long, sValueName As String, _
lType As Long, vValue As Variant) As Long
    Dim lValue As Long
    Dim sValue As String
    Select Case lType
        Case REG_SZ
            sValue = vValue & Chr$(0)
            SetValueEx = RegSetValueExString(hKey, sValueName, 0&, _
                                           lType, sValue, Len(sValue))
        Case REG_DWORD
            lValue = vValue
            SetValueEx = RegSetValueExLong(hKey, sValueName, 0&, _
                                            lType, lValue, 4)
        End Select
End Function


Function QueryValueEx(ByVal lhKey As Long, ByVal szValueName As _
String, vValue As Variant) As Long
    Dim cch As Long
    Dim lrc As Long
    Dim lType As Long
    Dim lValue As Long
    Dim sValue As String

    On Error GoTo QueryValueExError

    ' Determine the size and type of data to be read
    lrc = RegQueryValueExNULL(lhKey, szValueName, 0&, lType, 0&, cch)
    If lrc <> ERROR_NONE Then Error 5

    Select Case lType
        ' For strings
        Case REG_SZ:
            sValue = String(cch, 0)
            lrc = RegQueryValueExString(lhKey, szValueName, 0&, lType, _
                sValue, cch)
            If lrc = ERROR_NONE Then
                ' GM 4/29/02 : Introduced cLast check.  Without the last character is lost
                ' Original code from Help: "INFO: Using the Registry API to Save and Retrieve Settings"
              Dim cLast: cLast = right(sValue, 1)
              If ((cLast = vbCr) Or (cLast = vbLf) Or (cLast = vbCrLf) Or (Asc(cLast) = 0)) Then
                vValue = left$(sValue, cch - 1)
              Else
                 vValue = sValue
              End If
            Else
                vValue = Empty
            End If
        ' For DWORDS
        Case REG_DWORD:
            lrc = RegQueryValueExLong(lhKey, szValueName, 0&, lType, _
                lValue, cch)
            If lrc = ERROR_NONE Then vValue = lValue
        Case Else
            'all other data types not supported
            lrc = -1
    End Select
QueryValueExExit:
    QueryValueEx = lrc
    Exit Function
QueryValueExError:
    Resume QueryValueExExit
End Function


Public Function QueryValueName(hRoot As Long, sKeyName As String, nValueIndex As Long) As Variant
   Dim lngKeyHandle As Long
   Dim lngResult As Long
   Dim lngCurIdx As Long
   Dim strValue As String
   Dim lngValueLen As Long
   Dim lngData As Long
   Dim lngDataLen As Long
   Dim strResult As String
   lngResult = RegOpenKeyEx(hRoot, sKeyName, _
          0&, _
          KEY_ALL_ACCESS, _
           lngKeyHandle)
   If lngResult <> ERROR_SUCCESS Then
      Exit Function
   End If

  lngCurIdx = 0
  Do
     lngValueLen = 2000
     strValue = String(lngValueLen, 0)
     lngDataLen = 2000

     lngResult = RegEnumValue(lngKeyHandle, _
                              lngCurIdx, _
                              ByVal strValue, _
                              lngValueLen, _
                              0&, _
                              REG_DWORD, _
                              ByVal lngData, _
                              lngDataLen)
     lngCurIdx = lngCurIdx + 1
     If lngResult = ERROR_SUCCESS Then
      If (lngCurIdx = nValueIndex) Then
         QueryValueName = strValue
         Exit Function
       End If
     End If
  Loop While lngResult = ERROR_SUCCESS
  RegCloseKey (lngKeyHandle)
End Function

Public Sub DisplaySystemError()
  Dim Msg As String
  If Err.Number <> 0 Then
   Msg = "Error # " & str(Err.Number) & " was generated by " _
         & Err.Source & Chr(13) & Err.Description
   MsgBox Msg, , "Error" ', Err.HelpFile, Err.HelpContext
  End If
End Sub

' Data are read from:  MuComputer\HKEY_CURRENT_USER\Software\VB and VBA Program Seetings\<app>
Public Sub LoadSettings(Form As Object, Optional ApplicationName As String = "", Optional SectionName As String = "")
  Dim i As Integer
  Dim AName As String, sName As String
  AName = IIf(ApplicationName = "", App.EXEName, ApplicationName)
  sName = IIf(SectionName = "", Form.Name, SectionName)
  On Error Resume Next
        '  Read settings from registry
  For i = 0 To Form.Controls.Count - 1
    If TypeOf Form.Controls(i) Is CheckBox Then
        Form.Controls(i).Value = GetSetting(AName, sName, Form.Controls(i).Name, CStr(Form.Controls(i).Value))
    ElseIf TypeOf Form.Controls(i) Is ComboBox Then
        Form.Controls(i).ListIndex = GetSetting(AName, sName, Form.Controls(i).Name, CStr(Form.Controls(i).ListIndex))
    ElseIf TypeOf Form.Controls(i) Is OptionButton Then
        Form.Controls(i).Value = GetSetting(AName, sName, Form.Controls(i).Name & CStr(Form.Controls(i).Index), CStr(Form.Controls(i).Value))
    ElseIf TypeOf Form.Controls(i) Is TextBox Then
      If (right(Form.Controls(i).Name, 1) = "_") Then _
        Form.Controls(i).Text = GetSetting(AName, sName, Form.Controls(i).Name, Form.Controls(i).Text)
    End If
  Next i
  
    '----------------------------------------------------------
    ' Get:  If no coordinates were saved, center the screen;
    ' otherwise, get the last window position.
    '----------------------------------------------------------
    If GetSetting(AName, sName, "WposLeft") = Empty Then
        Form.Move (Screen.Width - frmMain.Width) / 2, _
            (Screen.Height - frmMain.Height) / 2
    Else
        Form.left = GetSetting(AName, sName, "WposLeft")
        Form.top = GetSetting(AName, sName, "WposTop")
        Form.Width = GetSetting(AName, sName, "WposWidth")
        Form.Height = GetSetting(AName, sName, "WposHeight")
    End If

End Sub

' Data are read from:  MuComputer\HKEY_CURRENT_USER\Software\VB and VBA Program Seetings\<app>
Public Function LoadSettingApp(sItem, Optional ApplicationName As String = "", Optional SectionName As String = "")
  Dim AName As String, sSection As String
  AName = IIf(ApplicationName = "", App.EXEName, ApplicationName)
  sSection = IIf(SectionName = "", "Configuration", SectionName)
  LoadSettingApp = GetSetting(AName, sSection, sItem, "")
End Function

' Data are stored in:  MuComputer\HKEY_CURRENT_USER\Software\VB and VBA Program Seetings\<app>
Public Sub SaveSettings(Form As Object, Optional ApplicationName As String = "", Optional SectionName As String = "")
  Dim i As Integer
  Dim AName As String, sName As String
  AName = IIf(ApplicationName = "", App.EXEName, ApplicationName)
  sName = IIf(SectionName = "", Form.Name, SectionName)

  ' Save settings in registry for next invocation
  For i = 0 To Form.Controls.Count - 1
    If TypeOf Form.Controls(i) Is CheckBox Then
      SaveSetting AName, sName, Form.Controls(i).Name, Form.Controls(i).Value
    ElseIf TypeOf Form.Controls(i) Is ComboBox Then
      SaveSetting AName, sName, Form.Controls(i).Name, Form.Controls(i).ListIndex
    ElseIf TypeOf Form.Controls(i) Is OptionButton Then
      SaveSetting AName, sName, Form.Controls(i).Name & CStr(Form.Controls(i).Index), Form.Controls(i).Value
    ElseIf TypeOf Form.Controls(i) Is TextBox Then
      If (right(Form.Controls(i).Name, 1) = "_") Then
        SaveSetting AName, sName, Form.Controls(i).Name, Form.Controls(i).Text
      End If
    End If
  Next
  
  If Form.WindowState <> vbMinimized Then
      SaveSetting AName, sName, "WposLeft", Form.left
      SaveSetting AName, sName, "WposTop", Form.top
      SaveSetting AName, sName, "WposWidth", Form.Width
      SaveSetting AName, sName, "WposHeight", Form.Height
  End If
End Sub

Public Sub SaveSettingApp(sItem, sValue, Optional ApplicationName As String = "", Optional SectionName As String = "")
  Dim AName As String, sSection As String
  AName = IIf(ApplicationName = "", App.EXEName, ApplicationName)
  sSection = IIf(SectionName = "", "Configuration", SectionName)
  SaveSetting AName, sSection, sItem, sValue
End Sub
