VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "ClearImage DLID Reader "
   ClientHeight    =   5280
   ClientLeft      =   1560
   ClientTop       =   1770
   ClientWidth     =   8700
   DrawStyle       =   5  'Transparent
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5280
   ScaleWidth      =   8700
   Begin ClearImageDLID_ExampleVB.ctrlImage ctrlImage1 
      Height          =   1215
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1215
      _ExtentX        =   2143
      _ExtentY        =   2143
   End
   Begin VB.TextBox txtLastFileName_ 
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   4920
      Visible         =   0   'False
      Width           =   3855
   End
   Begin VB.TextBox txtResult 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5055
      Left            =   4680
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "Main.frx":058A
      Top             =   120
      Width           =   3855
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&Server"
      Visible         =   0   'False
      Begin VB.Menu mnuFileServerInfo 
         Caption         =   "ClearImage Server Info"
      End
   End
   Begin VB.Menu mnuFileOpen 
      Caption         =   "&Open..."
   End
   Begin VB.Menu mnuRead2D 
      Caption         =   "&ReadPDF417"
   End
   Begin VB.Menu mnuRead1D 
      Caption         =   "Read1&D"
   End
   Begin VB.Menu mnuDecodeAAMVA 
      Caption         =   "DecodeDrvLic"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'===================================================================
' This file is provided as part of the ClearImage COM Development Kit
'
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT
' WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
' OF MERCHANTABILITY AND/OR FITNESS FOR A  PARTICULAR PURPOSE.
'
' Copyright (C) 2007-2008.  Inlite Research, Inc. All rights reserved
'===================================================================

Public oCiServer As ClearImage.CiServer
Public oCiImage As CiImage

Private Sub Form_Load()
  On Error GoTo DoExit
    '------------------------------------------------------------
    ' Create CiImage object
  Set oCiServer = New CiServer
  Set oCiImage = oCiServer.CreateImage
  Set ctrlImage1.oImage = oCiImage
    '------------------------------------------------------------
    ' Create CiImage object
  Me.Caption = App.Title
    '-------------------------------------------------------------
    ' Load settings stored in Registry
  LoadConfig
  '----------------------------------------------------------
  RsltClr
  Exit Sub
DoExit:
  ShowError
  End
End Sub


Private Sub Form_Resize()
  If frmMain.WindowState = 1 Or _
          frmMain.ScaleWidth < 1 Or _
          frmMain.ScaleHeight < 1 Then
      Exit Sub
  End If
  ctrlImage1.Top = 0:  ctrlImage1.Left = 0
  ctrlImage1.Height = Me.ScaleHeight
  ctrlImage1.Width = Me.ScaleWidth / 2

  txtResult.Top = 0:  txtResult.Left = Me.ScaleWidth / 2
  txtResult.Height = Me.ScaleHeight
  txtResult.Width = Me.ScaleWidth / 2
End Sub

Private Sub Form_Unload(Cancel As Integer)
  SaveConfig
End Sub

Private Sub SaveConfig()
  SaveSettings Me
End Sub

Private Sub LoadConfig()
  LoadSettings Me
End Sub

Private Sub RsltClr()
  txtResult = ""
End Sub

Private Sub RsltAdd(sMsg)
  txtResult = txtResult + sMsg + vbCrLf
End Sub



Public Sub ShowImage()
  On Error GoTo except
  ctrlImage1.UpdateImage
  If (oCiImage.fileName <> "") Then
    Me.Caption = App.Title & " File: " & oCiImage.fileName & "   Page: " & oCiImage.PageNumber
  Else
    Me.Caption = App.Title & " (unnamed)"
  End If
  Exit Sub
except: ShowError "ShowImage"
End Sub

Public Sub CloseImage()
  On Error GoTo except
  txtResult = ""
  ctrlImage1.CloseImage
  Me.Caption = App.Title
  oCiImage.Close
  Exit Sub
except: ShowError "CloseImage"
End Sub


Private Sub mnuDecodeAAMVA_Click()
  Call RsltClr:     RsltAdd "File: " & Me.txtLastFileName_
  Dim Bc As CiBarcode
  Set Bc = Read2D(Me.txtLastFileName_)
  If (Bc Is Nothing) Then RsltAdd "NO BARCODE"
  If (Bc Is Nothing) Then Exit Sub
  RsltAdd DecodeDrvLic(Bc.Text)
End Sub

Private Function DecodeDrvLic(sIn As String) As String
  On Error GoTo DoError
  Dim oDecoder As New DriverLicenseDecoder.DLDecoder
  Dim s As String
  oDecoder.Decode sIn
  If (oDecoder.xml <> "") Then
      s = s + "last:    " + oDecoder.Last + vbCrLf
      s = s + "first:   " + oDecoder.First + vbCrLf
      s = s + "middle:  " + oDecoder.middle + vbCrLf
      s = s + "suffix:  " + oDecoder.suffix + vbCrLf
      s = s + "dob:     " + oDecoder.dob + vbCrLf
      s = s + "eyes:    " + oDecoder.eyes + vbCrLf
      s = s + "hair:    " + oDecoder.hair + vbCrLf
      s = s + "sex:     " + oDecoder.sex + vbCrLf
      s = s + "height:  " + oDecoder.Height + vbCrLf
      s = s + "weight:  " + oDecoder.weight + vbCrLf
      s = s + "street:  " + oDecoder.street + vbCrLf
      s = s + "city:    " + oDecoder.city + vbCrLf
      s = s + "state:   " + oDecoder.state + vbCrLf
      s = s + "postal:  " + oDecoder.postal + vbCrLf
      s = s + "country: " + oDecoder.country + vbCrLf
      s = s + "id:      " + oDecoder.Id + vbCrLf
      s = s + "issued:  " + oDecoder.issued + vbCrLf
      s = s + "expires: " + oDecoder.expires + vbCrLf
      s = s + vbCrLf
      s = s + "XML Data: " + vbCrLf + oDecoder.xml + vbCrLf
  Else
      s = "Driver License / ID Card data are not present " & vbCrLf & sIn
  End If
  DecodeDrvLic = s
  Exit Function
DoError:
  ShowError
End Function

Private Sub mnuFileOpen_Click()
  On Error GoTo except
  Dim sFileName As String
  sFileName = FileOpenDialog(txtLastFileName_.Text)
  If (sFileName <> "") Then
    txtLastFileName_.Text = sFileName
    CloseImage
    oCiImage.Open txtLastFileName_.Text, 1
    ShowImage
    SaveConfig
    mnuImageProperties_Click    ' Display properties
  End If
  Exit Sub
except: ShowError "FileOpen"
End Sub

Private Sub mnuFileServerInfo_Click()
  RsltClr
  RsltAdd "ClearImage COM Server Version: " & oCiServer.VerMajor & "." & oCiServer.VerMinor & "." & oCiServer.VerRelease
  RsltAdd "Modules: " & vbCrLf & Replace(oCiServer.Info(ciModulesList), Chr(10), vbCrLf)
End Sub

Private Sub mnuImageProperties_Click()
  On Error GoTo except
  RsltClr
  RsltAdd "ClearImage COM Server Version: " & oCiServer.VerMajor & "." & oCiServer.VerMinor & "." & oCiServer.VerRelease
  If (oCiImage.fileName <> "") Then
    RsltAdd "FileName: " & oCiImage.fileName
'    RsltAdd "PageNumber: " & oCiImage.PageNumber
'    RsltAdd "PageCount: " & oCiImage.PageCount
  Else
    RsltAdd "FileName: " & "(unnamad)"
  End If
  RsltAdd "Width: " & oCiImage.Width
  RsltAdd "Height: " & oCiImage.Height
  RsltAdd "HorzDpi: " & oCiImage.HorzDpi
  RsltAdd "VertDpi: " & oCiImage.VertDpi
  RsltAdd "BitsPerPixel: " & oCiImage.BitsPerPixel
  If (ctrlImage1.IsSelection) Then
    Dim l As Long, r As Long, t As Long, b As Long
    ctrlImage1.Selection l, t, r, b
    RsltAdd "Slection: " & l & ":" & t & "-" & r & ":" & b
  End If
except:  ShowError "ImageProperties"
End Sub

Private Sub mnuRead1D_Click()
  Call RsltClr:     RsltAdd "File: " & Me.txtLastFileName_
  Dim Bc As CiBarcode
  Set Bc = Read1D(Me.txtLastFileName_)
  If (Not Bc Is Nothing) Then DisplayBarcode Bc
  If (Bc Is Nothing) Then RsltAdd "NO 1D BARCODE"
End Sub

Private Sub mnuRead2D_Click()
  Call RsltClr:       RsltAdd "File: " & Me.txtLastFileName_
  Dim Bc As CiBarcode
  Set Bc = Read2D(Me.txtLastFileName_)
  If (Not Bc Is Nothing) Then DisplayBarcode Bc
  If (Bc Is Nothing) Then RsltAdd "NO 2D BARCODE"
End Sub

Public Function Read1D(sFile As String) As CiBarcode
  On Error GoTo except
   ' ------------------- Create Reader
  Dim oReader As CiBarcodePro
  Set oReader = oCiServer.CreateBarcodePro
  oReader.Type = cibfCode128 Or cibfCode39
  oReader.Encodings = 102
    ' ------------------- Open image from file
  oReader.Image.Open sFile
    ' ------------------- Find barcodes
  Set Read1D = oReader.FirstBarcode
  Exit Function
except:  ShowError
End Function

Public Function Read2D(sFile) As CiBarcode
  On Error GoTo except
    ' ------------------- Create Reader
  Dim oReader As CiPdf417
  Set oReader = oCiServer.CreatePdf417
  oReader.Encodings = 102
    ' ------------------- Open image from file
  oReader.Image.Open sFile
  Set Read2D = oReader.FirstBarcode
  Exit Function
except:  ShowError
End Function

Private Sub DisplayBarcode(ByRef Bar As CiBarcode)
  RsltAdd "###################################"
  RsltAdd "Rect=" & RectToString(Bar.Rect)
  RsltAdd "Length=" & Bar.Length
  Dim sRot As String
  Select Case Bar.Rotation
    Case cibRotNone
      sRot = "None"
    Case cibRotLeft
      sRot = "Right"
    Case cibRotLeft
      sRot = "Left"
    Case cibRotUpsideDown
      sRot = "UpsideDown"
    Case cibRotDiag
      sRot = "Diagonal"
  End Select
  RsltAdd "Rotation=" & sRot
  If (Bar.ModuleSize > 0) Then _
    RsltAdd "Mod=" & Format(Bar.ModuleSize, "Fixed") & "pixels"
  ' RsltAdd "Binary=" & IIf(Bar.IsBinary, "True", "False")
        ' To show string containing non-ASCII convert each character in Bar.Data
  Dim sBar As String, c, s
  'Replace CrLf, Cr, Lf with CrLf for better readability
  s = Replace(Bar.Text, Chr(0), "")
  s = Replace(s, vbCrLf, Chr(10))
  s = Replace(s, Chr(13), Chr(10))
  s = Replace(s, Chr(10), vbCrLf)
'  RsltAdd "Text=" & s
  RsltAdd String(40, "=") + "    RAW DATA"
  RsltAdd s
  ctrlImage1.ClearSelection
  ctrlImage1.DrawSelection Bar.Rect.Left, Bar.Rect.Top, Bar.Rect.Right, Bar.Rect.bottom
End Sub

