VERSION 5.00
Begin VB.UserControl ctrlImage 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.PictureBox Picture1 
      BackColor       =   &H80000001&
      Height          =   3255
      Left            =   240
      ScaleHeight     =   3195
      ScaleWidth      =   4275
      TabIndex        =   0
      Top             =   120
      Width           =   4335
      Begin VB.Image Image1 
         Height          =   3015
         Left            =   120
         Top             =   120
         Width           =   4095
      End
   End
End
Attribute VB_Name = "ctrlImage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public oImage As CiImage
Private dScale As Double
Private StartX As Single, StartY As Single, OldX As Single, OldY As Single
Private bInSelection As Boolean

Public Event SelectionCompleted()
Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Public bEnableSelection

Private Function IsImageValid() As Boolean
  On Error GoTo DoExit
  If (oImage Is Nothing) Then Exit Function
  IsImageValid = oImage.IsValid
  Exit Function
DoExit:
End Function

Private Sub Image1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If (Not bEnableSelection) Then Exit Sub
  ClearSelection
  If IsImageValid Then
    Dim xi As Single, yi As Single
    xi = (X * dScale): Limit xi, 0, oImage.Width - 1
    yi = (Y * dScale): Limit yi, 0, oImage.Height - 1

     ' * Store the initial start of the line to draw.
    StartX = xi
    StartY = yi
    
    '* Make the last location equal the starting location
    OldX = StartX
    OldY = StartY
    bInSelection = True
  End If
End Sub

Private Sub Image1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'* If the button is depressed then...
   If Button And IsImageValid And bInSelection Then
      Dim xi As Single, yi As Single
      xi = (X * dScale): Limit xi, 0, oImage.Width - 1
      yi = (Y * dScale): Limit yi, 0, oImage.Height - 1
      '* Erase the previous line.
      Call DrawSelection(StartX, StartY, OldX, OldY)
      '* Draw the new line.
      Call DrawSelection(StartX, StartY, xi, yi)
      '* Save the coordinates for the next call.
      OldX = xi
      OldY = yi
   End If
End Sub

Private Sub Image1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If IsImageValid And bInSelection Then
    RaiseEvent SelectionCompleted
    bInSelection = False
  End If
End Sub

Sub DrawSelection(X1, Y1, X2, Y2 As Single, Optional nDrawMode = vbInvert)
  If IsImageValid And (dScale > 0#) Then
    Dim SavedMode: SavedMode = Picture1.DrawMode
    Picture1.DrawMode = nDrawMode
    Picture1.DrawStyle = vbDash
    Picture1.Line (X1 / dScale, Y1 / dScale)-(X2 / dScale, Y2 / dScale), , B
    Picture1.DrawMode = SavedMode
  End If
End Sub


Private Sub UserControl_Resize()
  Picture1.Visible = False
  Picture1.Top = 0:  Picture1.Left = 0
  Picture1.Height = UserControl.ScaleHeight
  Picture1.Width = UserControl.ScaleWidth
  Image1.Visible = False
  Image1.Top = 0:  Image1.Left = 0
  Image1.Height = Height
  Image1.Width = Width
  If (IsImageValid) Then
    If (oImage.Width > 0 And Image1.Width > 0 And Image1.Height > 0) Then
      Dim xScale As Double, yScale As Double
      xScale = CDbl(oImage.Width) / Image1.Width
      yScale = CDbl(oImage.Height) / Image1.Height
      dScale = xScale
      If (dScale < yScale) Then dScale = yScale
      Image1.Width = CDbl(oImage.Width) / dScale
      Image1.Height = CDbl(oImage.Height) / dScale
      Image1.Stretch = True
    End If
 End If
 Image1.Visible = True
 Picture1.Visible = True
 If (IsSelection) Then
   Picture1.Cls
   Call DrawSelection(StartX, StartY, OldX, OldY)
 End If
End Sub

Private Function GetTempFileBMP() As String
   GetTempFileBMP = "c:\_abc.bmp"
   Dim PathString As String, fileName As String
   Dim RetLength As Long, RetValue As Long
   On Error Resume Next
   PathString = Space$(260)
   fileName = Space$(340)
   RetLength = GetTempPath(260, PathString)
   PathString = Left$(PathString, RetLength)
   If RetLength > 0 Then
       RetValue = GetTempFileName(PathString, "", 0, fileName)
       If RetValue <> 0 Then
           RetLength = InStr(fileName, vbNullChar) - 1
           If (RetLength > 4) Then GetTempFileBMP = Left$(fileName, RetLength - 3) & "bmp"
       End If
    End If
End Function


'---------------------------------------
'  To load image into Image Control use LoadPicture
'    and temporary file.
'  Use temporary CiImage to create temporary file since
'    SaveAs method changes FileName property.
Public Sub UpdateImage()
  On Error GoTo except
  Dim oTemp As CiImage
  If oImage.IsValid = ciFalse Then Exit Sub
  Set oTemp = oImage.Duplicate
  Dim sFileName: sFileName = GetTempFileBMP
  oTemp.SaveAs sFileName
  Image1.Picture = LoadPicture(sFileName)
  UserControl_Resize
  Kill sFileName
  Exit Sub
except: ShowError "UpdateImage"
End Sub

Public Sub CloseImage()
  On Error GoTo except
  ClearSelection
  Image1.Picture = Nothing
  Exit Sub
except: ShowError "CloseImage"
End Sub

Public Sub ClearSelection()
  StartX = 0: StartY = 0: OldX = 0: OldY = 0
  bInSelection = False
  Picture1.Cls
End Sub

Public Function IsSelection()
  Dim l As Long, r As Long, t As Long, b As Long
  Selection l, t, r, b
  IsSelection = (r > l) And (b > t)
End Function

Private Sub Limit(ByRef val, minv, maxv)
  If (val < minv) Then val = minv
  If (val > maxv) Then val = maxv
End Sub


Public Sub Selection(ByRef l As Long, ByRef t As Long, ByRef r As Long, ByRef b As Long)
  l = 0: r = 0: t = 0: b = 0
  
  If (Not IsImageValid) Then Exit Sub
    ' Scale and clip
  l = CLng(StartX)
  r = CLng(OldX)
  t = CLng(StartY)
  b = CLng(OldY)
    ' Normalize
  Dim i
  If (l > r) Then i = r: r = l: l = i
  If (t > b) Then i = b: b = t: t = i
    ' Set minimum size
  If (l > (r - 2)) Then GoTo DoEmpty
  If (t > (b - 2)) Then GoTo DoEmpty
  Exit Sub
DoEmpty:
  l = 0: r = 0: t = 0: b = 0
End Sub
